package cn.com.qmth.stmms.admin.thread;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import cn.com.qmth.stmms.biz.exam.model.ExamQuestion;
import cn.com.qmth.stmms.biz.lock.LockService;
import cn.com.qmth.stmms.biz.mark.service.MarkService;
import cn.com.qmth.stmms.common.enums.LockType;

public class QuestionDeleteThread implements Runnable {

    protected static Logger log = LoggerFactory.getLogger(QuestionDeleteThread.class);

    private List<ExamQuestion> list;

    private MarkService markService;

    private LockService lockService;

    private Map<Integer, String> map;

    public QuestionDeleteThread(List<ExamQuestion> list, MarkService markService, LockService lockService) {
        this.list = list;
        this.markService = markService;
        this.lockService = lockService;
    }

    @Override
    public void run() {
        if (list == null || list.isEmpty()) {
            return;
        }
        int examId = list.get(0).getExamId();
        String subjectCode = list.get(0).getSubjectCode();
        map = new HashMap<Integer, String>();
        for (ExamQuestion examQuestion : list) {
            map.put(examQuestion.getMainNumber(), examQuestion.getSubNumber());
        }
        try {
            lockService.waitlock(LockType.EXAM_SUBJECT, examId, subjectCode);
            log.info("delete question examId=" + examId + " subjectCode=" + subjectCode);
            markService.deleteByQuestion(list);
        } catch (Exception e) {
            log.error("delete group error", e);
        } finally {
            lockService.unlock(LockType.EXAM_SUBJECT, examId, subjectCode);
            for (Integer mainNumber : map.keySet()) {
                lockService.unlock(LockType.QUESTION_DELETE, examId, subjectCode, mainNumber, map.get(mainNumber));
            }
        }
    }

}
